<script setup lang="ts">
    import { graphql } from "./../../gql/index";
    import { computed } from "vue";
    import { useQuery } from "@vue/apollo-composable";
    import useNavigationStore from "./../../stores/navigation";
    import useAuthStore from "./../../stores/auth";
    import { pushToClipboard } from "./../../functions/clipboard";
    import { SexEnum } from "../../gql/graphql";
    import { SexEnumTranslation } from "../../gql/enum-translations";
    import { openBrowser } from "../../functions/open";
    import { baseURL } from "../../functions/env";

    const navigationStore = useNavigationStore();
    const authStore = useAuthStore();

    // graphql
    const instructorQueryVariables = computed(() => {
        return {
            id: navigationStore.instructorId,
        };
    });
    const instructorQuery = graphql(`
        query InstructorBaseDataQuery($id: Uuid = "00000000-0000-0000-0000-000000000000") {
            instructor(id: $id) {
                id
                givenName
                familyName
                callName
                sex
                gender
                birthDate
                street
                streetNumber
                postalCode
                city
                country
                email
                keycloakId
                keycloakUsername
                telephone
                pronoun
                abbreviation
                iban
            }
        }
    `);
    const { result: resultInstructor } = useQuery(instructorQuery, instructorQueryVariables, {
        fetchPolicy: "cache-and-network",
    });
    const instructor = computed(() => {
        return resultInstructor.value?.instructor!;
    });

    const sexSelect = computed(() => {
        let res = [] as { value: SexEnum; title: string }[];

        // do not include redacted, therefore no "Object.values"
        [SexEnum.Male, SexEnum.Female, SexEnum.Diverse].forEach((sex) => {
            res.push({
                value: sex,
                title: SexEnumTranslation(sex),
            });
        });

        return res;
    });

    const givenName = computed(() => {
        return instructor.value?.givenName ?? "";
    });
    const callName = computed(() => {
        return instructor.value?.callName ?? "";
    });
    const familyName = computed(() => {
        return instructor.value?.familyName ?? "";
    });
    const sex = computed(() => {
        return instructor.value?.sex ?? "";
    });
    const gender = computed(() => {
        return instructor.value?.gender ?? "";
    });
    const pronoun = computed(() => {
        return instructor.value?.pronoun ?? "";
    });
    const birthDate = computed(() => {
        return instructor.value?.birthDate ?? "";
    });
    const street = computed(() => {
        return instructor.value?.street ?? "";
    });
    const streetNumber = computed(() => {
        return instructor.value?.streetNumber ?? "";
    });
    const postalCode = computed(() => {
        return instructor.value?.postalCode ?? "";
    });
    const city = computed(() => {
        return instructor.value?.city ?? "";
    });
    const country = computed(() => {
        return instructor.value?.country ?? "";
    });
    const email = computed(() => {
        return instructor.value?.email ?? "";
    });
    const keycloakUsername = computed(() => {
        return instructor.value?.keycloakUsername ?? "";
    });
    const telephone = computed(() => {
        return instructor.value?.telephone ?? "";
    });
    const abbreviation = computed(() => {
        return instructor.value?.abbreviation ?? "";
    });
    const iban = computed(() => {
        return instructor.value?.iban ?? "";
    });
</script>

<template>
    <v-row v-if="instructor && instructor != null" class="mb-6 justify-center" no-gutters dense>
        <v-btn
            class="v-col-md-6 v-col-12 mb-3"
            @click="openBrowser(baseURL() + 'account')"
            v-if="instructor.id == authStore.ownInstructorUuid"
        >
            <template v-slot:prepend> <span class="material-symbols-outlined"> edit </span></template>
            Stammdaten bearbeiten
        </v-btn>
        <v-text-field
            density="comfortable"
            v-model="instructor.id"
            label="UUID"
            class="v-col-md-7"
            append-inner-icon="mdi-content-copy"
            readonly
            @click:append-inner="pushToClipboard(instructor.id, 'ID kopiert')"
        ></v-text-field>
        <v-text-field density="comfortable" v-model="givenName" label="Vorname" class="v-col-md-7" readonly></v-text-field>
        <v-text-field density="comfortable" v-model="callName" label="Rufname" class="v-col-md-7" readonly></v-text-field>
        <v-text-field density="comfortable" v-model="familyName" label="Familienname" class="v-col-md-7" readonly></v-text-field>
        <v-text-field
            density="comfortable"
            v-model="email"
            label="Email-Adresse"
            class="v-col-md-7"
            readonly
            append-inner-icon="mdi-content-copy"
            @click:append-inner="pushToClipboard(email, 'Email-Adresse kopiert')"
        ></v-text-field>
        <v-text-field
            density="comfortable"
            v-model="telephone"
            label="Telefonnummer"
            class="v-col-md-7"
            readonly
            append-inner-icon="mdi-content-copy"
            @click:append-inner="pushToClipboard(telephone, 'Telefonnummer kopiert')"
        ></v-text-field>
        <v-text-field
            density="comfortable"
            v-model="instructor.keycloakId"
            label="Keycloak UUID"
            class="v-col-md-7"
            append-inner-icon="mdi-content-copy"
            readonly
            @click:append-inner="pushToClipboard(instructor.keycloakId, 'UUID kopiert')"
        ></v-text-field>
        <v-select
            readonly
            class="v-col-md-7"
            density="comfortable"
            v-model="sex"
            label="Sex (Rechtliches Geschlecht)"
            :items="sexSelect"
        ></v-select>
        <v-text-field
            density="comfortable"
            v-model="gender"
            label="Gender (präferiertes Geschlecht)"
            class="v-col-md-7"
            readonly
        ></v-text-field>
        <v-text-field density="comfortable" v-model="pronoun" label="Pronomen" class="v-col-md-7" readonly></v-text-field>
        <v-text-field density="comfortable" v-model="abbreviation" label="Abkürzung" class="v-col-md-7" readonly></v-text-field>
        <v-text-field density="comfortable" v-model="birthDate" label="Geburtstag" class="v-col-md-7" readonly></v-text-field>
        <v-text-field density="comfortable" v-model="street" label="Straßenname" class="v-col-md-7" readonly></v-text-field>
        <v-text-field density="comfortable" v-model="streetNumber" label="Hausnummer" class="v-col-md-7" readonly></v-text-field>
        <v-text-field density="comfortable" v-model="postalCode" label="Postleitzahl" class="v-col-md-7" readonly></v-text-field>
        <v-text-field density="comfortable" v-model="city" label="Stadt" class="v-col-md-7" readonly></v-text-field>
        <v-text-field density="comfortable" v-model="country" label="Land" class="v-col-md-7" readonly></v-text-field>
        <v-text-field density="comfortable" v-model="iban" label="IBAN" class="v-col-md-7" readonly></v-text-field>
        <v-text-field
            density="comfortable"
            v-model="keycloakUsername"
            label="Keycloak Username"
            class="v-col-md-7"
            append-inner-icon="mdi-content-copy"
            readonly
            @click:append-inner="pushToClipboard(keycloakUsername, 'Username kopiert')"
        ></v-text-field>
    </v-row>
</template>
